part of '../../../store_management.dart';

@dao
abstract class ProductStorageDbSet extends ModelDbSet<ProductStorageModel> {
  @Query('SELECT * FROM ProductStorage')
  Future<List<ProductStorageModel>> findAll();
  @Query('SELECT * FROM ProductStorage')
  Stream<List<ProductStorageModel>> findAllAsStream();

  @Query('''SELECT * FROM ProductStorage WHERE
       (0 = :productId or product_id = :productId) and
       (0 = :branchId or branch_id = :branchId) and
       (0 = :storeId or store_id = :storeId) and
       (0 = :currencyId or currency_id = :currencyId)''')
  Future<List<ProductStorageModel>> findBy(
      int productId, int branchId, int storeId, int currencyId);

  @Query('''SELECT * FROM ProductStorage WHERE
       (0 = :productId or product_id = :productId) and
       (0 = :branchId or branch_id = :branchId) and
       (0 = :storeId or store_id = :storeId) and
       (0 = :currencyId or currency_id = :currencyId)''')
  Stream<List<ProductStorageModel>> findByAsStream(
      int productId, int branchId, int storeId, int currencyId);

  @Query('''SELECT sum(count) FROM ProductStorage WHERE
       (0 = :productId or product_id = :productId) and
       (0 = :branchId or branch_id = :branchId) and
       (0 = :storeId or store_id = :storeId) and
       (0 = :currencyId or currency_id = :currencyId)''')
  Future<int?> sumOf(int productId, int branchId, int storeId, int currencyId);
}
